import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DescribeHealthServiceStatusForOrganizationCommand, se_DescribeHealthServiceStatusForOrganizationCommand, } from "../protocols/Aws_json1_1";
export { $Command };
export class DescribeHealthServiceStatusForOrganizationCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSHealth_20160804", "DescribeHealthServiceStatusForOrganization", {})
    .n("HealthClient", "DescribeHealthServiceStatusForOrganizationCommand")
    .f(void 0, void 0)
    .ser(se_DescribeHealthServiceStatusForOrganizationCommand)
    .de(de_DescribeHealthServiceStatusForOrganizationCommand)
    .build() {
}
