import { HealthServiceException as __BaseException } from "./HealthServiceException";
export const EntityStatusCode = {
    IMPAIRED: "IMPAIRED",
    PENDING: "PENDING",
    RESOLVED: "RESOLVED",
    UNIMPAIRED: "UNIMPAIRED",
    UNKNOWN: "UNKNOWN",
};
export const EventScopeCode = {
    ACCOUNT_SPECIFIC: "ACCOUNT_SPECIFIC",
    NONE: "NONE",
    PUBLIC: "PUBLIC",
};
export class InvalidPaginationToken extends __BaseException {
    name = "InvalidPaginationToken";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidPaginationToken",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidPaginationToken.prototype);
    }
}
export class UnsupportedLocale extends __BaseException {
    name = "UnsupportedLocale";
    $fault = "client";
    constructor(opts) {
        super({
            name: "UnsupportedLocale",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, UnsupportedLocale.prototype);
    }
}
export const EventAggregateField = {
    EventTypeCategory: "eventTypeCategory",
};
export const EventStatusCode = {
    CLOSED: "closed",
    OPEN: "open",
    UPCOMING: "upcoming",
};
export const EventTypeCategory = {
    ACCOUNT_NOTIFICATION: "accountNotification",
    INVESTIGATION: "investigation",
    ISSUE: "issue",
    SCHEDULED_CHANGE: "scheduledChange",
};
export class ConcurrentModificationException extends __BaseException {
    name = "ConcurrentModificationException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ConcurrentModificationException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ConcurrentModificationException.prototype);
    }
}
