import { Command as $Command } from "@smithy/smithy-client";
import { MetadataBearer as __MetadataBearer } from "@smithy/types";
import { HealthClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../HealthClient";
import { DescribeHealthServiceStatusForOrganizationResponse } from "../models/models_0";
/**
 * @public
 */
export type { __MetadataBearer };
export { $Command };
/**
 * @public
 *
 * The input for {@link DescribeHealthServiceStatusForOrganizationCommand}.
 */
export interface DescribeHealthServiceStatusForOrganizationCommandInput {
}
/**
 * @public
 *
 * The output of {@link DescribeHealthServiceStatusForOrganizationCommand}.
 */
export interface DescribeHealthServiceStatusForOrganizationCommandOutput extends DescribeHealthServiceStatusForOrganizationResponse, __MetadataBearer {
}
declare const DescribeHealthServiceStatusForOrganizationCommand_base: {
    new (input: DescribeHealthServiceStatusForOrganizationCommandInput): import("@smithy/smithy-client").CommandImpl<DescribeHealthServiceStatusForOrganizationCommandInput, DescribeHealthServiceStatusForOrganizationCommandOutput, HealthClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes>;
    new (...[input]: [] | [DescribeHealthServiceStatusForOrganizationCommandInput]): import("@smithy/smithy-client").CommandImpl<DescribeHealthServiceStatusForOrganizationCommandInput, DescribeHealthServiceStatusForOrganizationCommandOutput, HealthClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes>;
    getEndpointParameterInstructions(): import("@smithy/middleware-endpoint").EndpointParameterInstructions;
};
/**
 * <p>This operation provides status information on enabling or disabling Health to work
 *          with your organization. To call this operation, you must use the organization's
 *          management account.</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { HealthClient, DescribeHealthServiceStatusForOrganizationCommand } from "@aws-sdk/client-health"; // ES Modules import
 * // const { HealthClient, DescribeHealthServiceStatusForOrganizationCommand } = require("@aws-sdk/client-health"); // CommonJS import
 * const client = new HealthClient(config);
 * const input = {};
 * const command = new DescribeHealthServiceStatusForOrganizationCommand(input);
 * const response = await client.send(command);
 * // { // DescribeHealthServiceStatusForOrganizationResponse
 * //   healthServiceAccessStatusForOrganization: "STRING_VALUE",
 * // };
 *
 * ```
 *
 * @param DescribeHealthServiceStatusForOrganizationCommandInput - {@link DescribeHealthServiceStatusForOrganizationCommandInput}
 * @returns {@link DescribeHealthServiceStatusForOrganizationCommandOutput}
 * @see {@link DescribeHealthServiceStatusForOrganizationCommandInput} for command's `input` shape.
 * @see {@link DescribeHealthServiceStatusForOrganizationCommandOutput} for command's `response` shape.
 * @see {@link HealthClientResolvedConfig | config} for HealthClient's `config` shape.
 *
 * @throws {@link HealthServiceException}
 * <p>Base exception class for all service exceptions from Health service.</p>
 *
 * @public
 */
export declare class DescribeHealthServiceStatusForOrganizationCommand extends DescribeHealthServiceStatusForOrganizationCommand_base {
    /** @internal type navigation helper, not in runtime. */
    protected static __types: {
        api: {
            input: {};
            output: DescribeHealthServiceStatusForOrganizationResponse;
        };
        sdk: {
            input: DescribeHealthServiceStatusForOrganizationCommandInput;
            output: DescribeHealthServiceStatusForOrganizationCommandOutput;
        };
    };
}
