import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { HealthClientResolvedConfig } from "../HealthClient";
export interface HealthHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface HealthHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    HealthClientResolvedConfig,
    HandlerExecutionContext,
    HealthHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultHealthHttpAuthSchemeParametersProvider: (
  config: HealthClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<HealthHttpAuthSchemeParameters>;
export interface HealthHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<HealthHttpAuthSchemeParameters> {}
export declare const defaultHealthHttpAuthSchemeProvider: HealthHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: HealthHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: HealthHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
