import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  DescribeAffectedAccountsForOrganizationCommandInput,
  DescribeAffectedAccountsForOrganizationCommandOutput,
} from "../commands/DescribeAffectedAccountsForOrganizationCommand";
import {
  DescribeAffectedEntitiesCommandInput,
  DescribeAffectedEntitiesCommandOutput,
} from "../commands/DescribeAffectedEntitiesCommand";
import {
  DescribeAffectedEntitiesForOrganizationCommandInput,
  DescribeAffectedEntitiesForOrganizationCommandOutput,
} from "../commands/DescribeAffectedEntitiesForOrganizationCommand";
import {
  DescribeEntityAggregatesCommandInput,
  DescribeEntityAggregatesCommandOutput,
} from "../commands/DescribeEntityAggregatesCommand";
import {
  DescribeEntityAggregatesForOrganizationCommandInput,
  DescribeEntityAggregatesForOrganizationCommandOutput,
} from "../commands/DescribeEntityAggregatesForOrganizationCommand";
import {
  DescribeEventAggregatesCommandInput,
  DescribeEventAggregatesCommandOutput,
} from "../commands/DescribeEventAggregatesCommand";
import {
  DescribeEventDetailsCommandInput,
  DescribeEventDetailsCommandOutput,
} from "../commands/DescribeEventDetailsCommand";
import {
  DescribeEventDetailsForOrganizationCommandInput,
  DescribeEventDetailsForOrganizationCommandOutput,
} from "../commands/DescribeEventDetailsForOrganizationCommand";
import {
  DescribeEventsCommandInput,
  DescribeEventsCommandOutput,
} from "../commands/DescribeEventsCommand";
import {
  DescribeEventsForOrganizationCommandInput,
  DescribeEventsForOrganizationCommandOutput,
} from "../commands/DescribeEventsForOrganizationCommand";
import {
  DescribeEventTypesCommandInput,
  DescribeEventTypesCommandOutput,
} from "../commands/DescribeEventTypesCommand";
import {
  DescribeHealthServiceStatusForOrganizationCommandInput,
  DescribeHealthServiceStatusForOrganizationCommandOutput,
} from "../commands/DescribeHealthServiceStatusForOrganizationCommand";
import {
  DisableHealthServiceAccessForOrganizationCommandInput,
  DisableHealthServiceAccessForOrganizationCommandOutput,
} from "../commands/DisableHealthServiceAccessForOrganizationCommand";
import {
  EnableHealthServiceAccessForOrganizationCommandInput,
  EnableHealthServiceAccessForOrganizationCommandOutput,
} from "../commands/EnableHealthServiceAccessForOrganizationCommand";
export declare const se_DescribeAffectedAccountsForOrganizationCommand: (
  input: DescribeAffectedAccountsForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeAffectedEntitiesCommand: (
  input: DescribeAffectedEntitiesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeAffectedEntitiesForOrganizationCommand: (
  input: DescribeAffectedEntitiesForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEntityAggregatesCommand: (
  input: DescribeEntityAggregatesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEntityAggregatesForOrganizationCommand: (
  input: DescribeEntityAggregatesForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEventAggregatesCommand: (
  input: DescribeEventAggregatesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEventDetailsCommand: (
  input: DescribeEventDetailsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEventDetailsForOrganizationCommand: (
  input: DescribeEventDetailsForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEventsCommand: (
  input: DescribeEventsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEventsForOrganizationCommand: (
  input: DescribeEventsForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeEventTypesCommand: (
  input: DescribeEventTypesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeHealthServiceStatusForOrganizationCommand: (
  input: DescribeHealthServiceStatusForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DisableHealthServiceAccessForOrganizationCommand: (
  input: DisableHealthServiceAccessForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_EnableHealthServiceAccessForOrganizationCommand: (
  input: EnableHealthServiceAccessForOrganizationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_DescribeAffectedAccountsForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeAffectedAccountsForOrganizationCommandOutput>;
export declare const de_DescribeAffectedEntitiesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeAffectedEntitiesCommandOutput>;
export declare const de_DescribeAffectedEntitiesForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeAffectedEntitiesForOrganizationCommandOutput>;
export declare const de_DescribeEntityAggregatesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEntityAggregatesCommandOutput>;
export declare const de_DescribeEntityAggregatesForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEntityAggregatesForOrganizationCommandOutput>;
export declare const de_DescribeEventAggregatesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEventAggregatesCommandOutput>;
export declare const de_DescribeEventDetailsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEventDetailsCommandOutput>;
export declare const de_DescribeEventDetailsForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEventDetailsForOrganizationCommandOutput>;
export declare const de_DescribeEventsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEventsCommandOutput>;
export declare const de_DescribeEventsForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEventsForOrganizationCommandOutput>;
export declare const de_DescribeEventTypesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeEventTypesCommandOutput>;
export declare const de_DescribeHealthServiceStatusForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeHealthServiceStatusForOrganizationCommandOutput>;
export declare const de_DisableHealthServiceAccessForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DisableHealthServiceAccessForOrganizationCommandOutput>;
export declare const de_EnableHealthServiceAccessForOrganizationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<EnableHealthServiceAccessForOrganizationCommandOutput>;
